#!/bin/sh
# psvutil.sh for SYNOLOGY NAS device
SCRIPTPATH=`dirname $0`
# Change working dir
cd ${SCRIPTPATH}

. ./common.sh

resources() {
qn_write header ${_QN_RES_FILE} resources
    list=$(df -B 1 | grep "/dev/vg*\|/dev/sd")
    IFS=$'\n'
    i=0
    for item in $list
    do
        if [[ $item == /* ]]; then
            mount=$(echo $item | awk '{print $6}')
            dev=$(echo $item | awk '{print $1}')
            if [[ $mount == *['USB']* ]]; then
                # Ivan: Get share name of the mounted volume
                local lstTmp=$(synoshare --enummnt ${mount})
                if [[ $'{#lstTmp[@]}' == 2 ]]; then
                    name=$'{lstTmp[1]}'
                else
                    # fallback to mount basename
                    name=$(basename $mount)
                fi
            else
                name=$(basename $dev)
            fi
            size=$(echo $item | awk '{print $2}')
            free=$(echo $item | awk '{print $4}')
            qn_write element ${_QN_RES_FILE} $i $name $size $free
        fi
        i=$((i+1))
    done
qn_write footer ${_QN_RES_FILE}
}

folders() {
    # qn_write predefined_shares ${_QN_SHARES_FILE}
    cat << EOF > ${_QN_SHARES_FILE}
{
    "shares":[
        {"collection":"SMB"},
        {"name":"Home", "alt":".%name's Home", "path":"%home", "icon":"HOME", "hideEmpty":false},
        {"name":"Network", "alt":"", "path":"smb://", "icon":"NETWORK", "hideEmpty":false}
    ]
}
EOF
}

# Get environment status.
getHealthTest(){
    # Firewall cant't be controlled for command line so output is always NORMAL.
    ReportHealthNormal
}

qn_main_exec $1
