/**
 * Copyright Qnext Inc. 2002-2017
 * http://www.qnext.com
 * Date: 14.10.2017
 * Time: 12:00
 * Author Iliya Kinanev (iliyak@qnext.com)
 * Author Petar Vanchev (petarv@qnext.com)
 */

$(document).ready(function() {

    var buttonDone = $("#buttonDone");

    function checkboxTextCheck() {
        if(checkbox.disabled === false) {
            if (checkbox.checked) {
                checkbox.checked = false;
                sendLogsButton.disabled = true;
            } else {
                checkbox.checked = true;
                sendLogsButton.disabled = false;
            }
        }
    }

    function updateSendBtnState() {
        var isDisabled = !checkbox.checked;
        if(!isDisabled) {
            var steps = description.value.trim();
            isDisabled = steps.length <= 0;
        }

        sendLogsButton.disabled = isDisabled;
    }

    function gatheringLogsStart() {
        sendLogsCont.style.display = 'none';
        gatheringCont.style.display = 'block';
        gatheringEnd.style.display = 'none';
        var desc = description.value.trim();
        var token = getGlobal(KEY_GLOBAL_CODE_ACTIVATE);
        var meta = getGlobal(KEY_GLOBAL_META);
        var handleError = function () {
            showMessage(ERROR_SEND_LOGS, "send_logs_error");

            gatheringStart.style.display = 'none';
            buttonDone.removeAttr('disabled');
        };
        if(token && meta && desc.length > 0) {
            // noinspection JSUnresolvedFunction
            $.ajax({
                method: "GET",
                url: "/",
                data: {
                    "cmd": "submit-logs",
                    "token": token,
                    "meta": meta,
                    "uid": getGlobal(KEY_GLOBAL_UID),
                    "description": description.value || undefined,
                    "mspId": getGlobal(KEY_GLOBAL_MSP_ID) || undefined
                },
                dataType: "text"
            }).done(function (resp) {
                log("fetchStatus success with: ");
                log(resp);
                gatheringLogsEnd();
            }).fail(function (jqXHR, textStatus, ex) {
                log("fetchStatus failure status: " + jqXHR.status + " " + textStatus +
                    (jqXHR.responseText ? ", response: " + jqXHR.responseText : "") +
                    (ex ? ", exception: " + ex : ""), true);
                handleError();
            });
        } else {
            handleError();
        }
    }


    function gatheringLogsEnd() {
        gatheringStart.style.display = 'none';
        gatheringEnd.style.display = 'block';
        buttonDone.removeAttr('disabled');
        refNumber.innerHTML = getGlobal(KEY_GLOBAL_CODE_ACTIVATE);
    }


    var checkbox = document.getElementById("sendLogsAgree");
    var sendLogsButton = document.getElementById("sendLogsButton");

    // Hide "Cancel" and "Done" buttons for browsers
     toggleButton(BTN_CANCEL_ID);
     toggleButton("buttonDone");

    var checkboxText = document.getElementById("checkboxText");
    var description = document.getElementById("descriptionData");
    var sendLogsCont = document.getElementById("sendLogsCont");
    var gatheringCont = document.getElementById("gatheringCont");
    var gatheringStart = document.getElementById("gatheringStart");
    var gatheringEnd = document.getElementById("gatheringEnd");
    var refNumber = document.getElementById("refNumber");


    // Set begin states for buttons and the checkbox
    checkbox.checked=true;
    checkbox.disabled=true;
    buttonDone.disabled = true;
    sendLogsButton.disabled = true;

    // Add click handlers
    checkboxText.addEventListener("click", checkboxTextCheck);
    checkbox.addEventListener("click", updateSendBtnState);
    sendLogsButton.addEventListener("click", gatheringLogsStart);
    // Add input handler to text area
    description.addEventListener("input", updateSendBtnState);

    $(document).ready(function() {
        QnLocale.initLocale(function () {
            // Optional for some inputs like checkboxes
            $(description).setTooltip("send_logs_textarea_placeholder");
            psvFetchStatus();
        }, true);
    });
});

